<?php
/*

>>>>>> CrazyStat <<<<<<
Ein komfortables, umfangreiches und kostenloses Statistik-Script mit oder ohne Counter.

Copyright (C) 2004-2007  Crazy Chrissi

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

E-Mail: christosoft4u@yahoo.de
Web: http://www.christosoft.de
Version: 1.61

*** stat.php ***
Funktion:    speichert Nutzerdaten und bindet Counter ein
Aufrufbar:   (ja)
Eingebunden: von eintrag.php (als Bild)

*/

ignore_user_abort(true);

function show_error($message2,$message1='FEHLER')
 {
 header('Content-type: image/png');
 $handle=imagecreate(150,30);
 $mes_farbe=imagecolorallocate($handle,255,255,255);
 $mes_farbe=imagecolorallocate($handle,255,0,0);
 imagestring($handle,1,1,1,$message1,$mes_farbe);
 imagestring($handle,1,1,15,$message2,$mes_farbe);
 imagepng($handle);
 imagedestroy($handle);
 exit;
 }

// Einlesen der Config-Daten
include_once('config.php');
// Log-Funktionen einbinden
require_once('log_funcs.php');

// Counter-aktivierung ueberschreiben?
if(isset($_GET['set_counter_enabled']) && $_GET['set_counter_enabled']=='true') $config_counter_enabled=true;
elseif(isset($_GET['set_counter_enabled']) && $_GET['set_counter_enabled']=='false') $config_counter_enabled=false;

// Counter-Grafik ueberschreiben?
if(isset($_GET['set_counter_datei_name']) && is_file($config_counter_ordner.'/'.$_GET['set_counter_datei_name'])) $config_counter_datei_name=$_GET['set_counter_datei_name'];


// Lese counter.log ein
$counterfile_path=$config_logdatei_ordner.'/'.$config_count_file;
if(is_file($counterfile_path))
 {
 $counterfile_data=file($counterfile_path);
 for($i=0; $i<=2; $i++)
  {
  if(!isset($counterfile_data[$i]) || $counterfile_data[$i]=='')
   {
   // Keine Daten. Eventuell greift gerade ein anderer Prozess auf die Datei zu, um sie zu updaten und hat die Datei vor dem
   // Schreiben geleert.
   $versuche=0;
   while((!isset($counterfile_data[$i]) || $counterfile_data[$i]=='') && $versuche<=10)
    {
    sleep(1); // warte 1 Sekunde, um dem andern Prozess Zeit zu geben
    $counterfile_data=file($counterfile_path);
    $versuche++;
    }
   if((!isset($counterfile_data[$i]) || $counterfile_data[$i]=='') && $versuche<10) exit;
   }
  else $counterfile_data[$i]=trim($counterfile_data[$i]);
  }
 }
else
 {
 $counterfile_data=array(0,0,0);
 }
 
$neue_datei=false;
$logfile_path=get_last_log();
if($neue_datei) $counterfile_data[0]=0; // Wenn eine neue Datei angelegt wurde muss am Anfang der datei angefangen werden zu lesen.
$readpos=$counterfile_data[0];          // Ab diesem Byte wird angefangen die (letzte) Logdatei auszuwerten

$logfile_handle=fopen($logfile_path,'r');
if($logfile_handle===false) show_error('Lesefehler (Rechte?) F1');
fseek($logfile_handle,$readpos);        // Starte nicht am Anfang, sondern da, wo das letzte Mal die neuen Zugriffe begonnen haben
$block=time()-$config_ip_sperre_zeit*60;// Alle Zugriffe nach $block fallen unter die IP-Sperre
$counter_reload=false;

$letzte_daten=array();
if($config_log_shrinked) get_letzte_daten($logfile_handle);

while(!feof($logfile_handle))
 {
 $zeile=fgets($logfile_handle);
 if(empty($zeile)) continue;

 $daten=explode('#',$zeile);
 
 if($config_log_ver==1.5) $daten=convert_log_data($daten);  // 1.5 logs in 1.6 konvertieren
 elseif($config_log_ver==1.6 && $config_log_shrinked) // "kompression"
  {
  foreach($daten as $id=>$data)
   {
   $data=trim($data);
   if($data!='^') $letzte_daten[$id]=$data;
   elseif(isset($letzte_daten[$id])) $daten[$id]=$letzte_daten[$id];
   }
  }

 if($daten[1]>=$block && !isset($writepos))
  {
  $writepos=ftell($logfile_handle)-strlen($zeile);
   /* Die aktuelle Zeile ist die erste, an der "neue" Zugriffe anfangen. D.h. diese Zugriffe liegen innerhalb der letzten
      $config_ip_sperre_zeit Minuten. Beim naechsten Mal wird am Anfang dieser Zeile angefangen zu lesen.                  */
  }
 if($daten[1]>=$block && $daten[2]==$_SERVER['REMOTE_ADDR'])
  {
  $counter_reload=true;
  if(!$config_log_shrink) break;  // Reaload wurde erkannt. Weiterlaufen nur fr Kompression ntig (letzte_daten[] fllen)
  }
 }
if(!isset($writepos)) $writepos=ftell($logfile_handle); // Keine Zugriffe in den letzten (Sperr-)Minuten=>Starte das naechste Mal bei diesem Zugriff

fclose($logfile_handle);

$anzahl_hits_ip=$counterfile_data[1];
$anzahl_hits=$counterfile_data[2];

// Robot-Block
$robots=file('robots.txt');
$is_robot=false;
foreach($robots as $robot)
 {
 if(strpos($_SERVER['HTTP_USER_AGENT'],trim($robot))!==false)
  {
  $is_robot=true;
  break;
  }
 }
if(!$counter_reload && !$is_robot) $anzahl_hits_ip++;
if(!$is_robot) $anzahl_hits++;

// fertig mit Lesen, fange an zu schreiben

if(!isset($_COOKIE['CrazyStat_DoNotCount']) || $_COOKIE['CrazyStat_DoNotCount']!='true') // wenn sperr-cookie nicht gesetzt, schreibe neuen Logeintrag
 {
 // Aktualisiere counter.log
 $counterfile_handle=fopen($counterfile_path,'w');
 @fwrite($counterfile_handle,$writepos."\n".$anzahl_hits_ip."\n".$anzahl_hits);
 @fclose($counterfile_handle);
 if($counterfile_handle===false) show_error('Schreibfehler(Rechte) F2');

 // Get-Daten zu Monitoraufloesung, Datei und Referer werden ausgelesen und verarbeitet
 if(empty($_GET['breite']) || empty($_GET['hoehe'])) $aufloesung='Sonstige / kein JS';
 else $aufloesung=$_GET['breite'].' x '.$_GET['hoehe'];
 if(empty($_GET['colors'])) $colors='';
 else $colors=$_GET['colors'];
 if(empty($_GET['datei'])) $datei='/Unbekannt';
 else $datei=$_GET['datei'];
 if(empty($_GET['referer'])) $referer='';
 else $referer=$_GET['referer'];

 // Es wird die neue Zeile zusammengesetzt
 $zeile='';
 if($config_log_ver==1.6)
  {
  unset($daten);
  $daten[0]=$anzahl_hits; $daten[1]=time(); $daten[2]=$_SERVER['REMOTE_ADDR']; $daten[3]=$datei; $daten[4]=$_SERVER['HTTP_USER_AGENT']; $daten[5]=$aufloesung; $daten[6]=$referer; $daten[7]=$colors;
  foreach($daten as $id=>$data)
   {
   if($id!=0) $zeile.='#';
   if($config_log_shrink && $id!=0 && !empty($letzte_daten[$id]) && $data==$letzte_daten[$id] && ($anzahl_hits%10)!=0 && !$neue_datei) $zeile.='^';  // "kompression"
   else $zeile.=$data;
   }
  $zeile.="\n";
  }
 else $zeile=$anzahl_hits.'#|#'.time().'#|#'.date('H#i#s#|#w#|#d#m#Y#|#').$_SERVER['REMOTE_ADDR'].'#|#'.$datei.'#|#'.$_SERVER['HTTP_USER_AGENT'].'#|#'.$aufloesung.'#|#'.$referer.'#|#'.$colors."\n";

 @$logfile_handle=fopen($logfile_path,'a');
 if($logfile_handle===false) show_error('Schreibfehler (Rechte?) F1');
 fwrite($logfile_handle,$zeile);
 fclose($logfile_handle);
 }
elseif($config_counter_cookie_text!==false) // Sperr-Cookie existiert=>"Cookie"-Text
 {
 // sperr-hinweis zeigen und Link setzen
 $config_counter_reload_show_text=$config_counter_cookie_text;
 $config_counter_reload=true;
 $config_counter_reload_show=true;
 $counter_reload=true;
 }

// Counter bzw. Ersatzbild wird ausgegeben
if($config_counter_enabled==false) header('Location: '.$config_counter_ersatz);
else include('create_counter_image.php');

?>